include	clib.inc
include	errno.inc
include	io.inc
ifndef __DZ__
	.code

chsize	proc _CType public uses rdi rsi handle:size_t, new_size:dword
local	zbuf[512]:byte
local	offs:dword
local	count:dword
ifndef	__f__
	mov ax,4201h		; save current offset
	mov bx,handle
	xor cx,cx
	mov dx,cx
	int 21h
	.if !CARRY?
	    mov word ptr offs,ax
	    mov word ptr offs+2,dx
	    mov ax,4202h	; seek to end of file
	    sub cx,cx
	    mov dx,cx
	    int 21h
	.endif
	.if !CARRY?
	    mov si,word ptr new_size+2
	    mov di,word ptr new_size
	    mov cx,si
	    .if dx > cx || dx == cx && ax > di
		mov ax,4200h	; Seek to new_size
		mov dx,di
		int 21h
		jc @F
		mov ah,40h
		sub cx,cx	; Write zero byte at current file position
		int 21h
		jc @F
	    .elseif dx < cx || dx == cx && ax < di
		push ax
		push ss
		pop es
		lea di,zbuf
		xor ax,ax
		mov cx,512/2
		cld?
		rep stosw
		pop ax
		mov di,word ptr new_size
		sub di,ax
		sbb si,dx
		mov word ptr count+2,0
		.repeat
		    mov word ptr count,512
		    .if si < word ptr count+2 || si == word ptr count+2 && di < 512
			mov word ptr count,di
			mov word ptr count+2,si
			.break .if !di
		    .endif
		    mov cx,word ptr count
		    sub di,cx
		    sbb si,word ptr count+2
		    lea dx,zbuf
		    mov ah,40h	; WRITE TO FILE OR DEVICE
		    int 21h
		    jc @F
		    .continue .if ax == cx
		    mov ax,ER_DISK_FULL
		    jmp @F
		.until 0
	    .endif
	    mov dx,word ptr offs
	    mov cx,word ptr offs+2
	    mov ax,4200h
	    int 21h
	    jc @F
	    sub ax,ax
	.else
	@@:
	    call osmaperr
	    mov ax,-1
	.endif
else
	invoke	lseek,handle,0,SEEK_SET
	mov	offs,eax	; save current offset
	dec	eax
	jz	chsize_fail	; seek to end of file
	invoke	lseek,handle,0,SEEK_END
	dec	eax
	jz	chsize_fail
	cmp	eax,new_size
	ja	truncate
	jb	chsize_inc
	jmp	chsize_back	; All done..
    chsize_inc:
	push	eax
	lea	edi,zbuf
	xor	eax,eax
	mov	ecx,512/4
	rep	stosd
	pop	eax
	mov	edi,new_size
	sub	edi,eax
    write_loop:
	mov	count,512
	cmp	edi,count
    write_loop_00:
	jae	write_chunk
	mov	count,edi
	or	edi,edi
	jz	chsize_back
    write_chunk:
	sub	edi,count
	invoke	oswrite,handle,addr zbuf,count
	cmp	eax,count
	je	write_loop
	mov	errno,ER_DISK_FULL
	sub	eax,eax
    chsize_fail:
	dec	eax
	jmp	chsize_end
    truncate:
	invoke	lseek,handle,new_size,SEEK_SET
	dec	eax
	jz	chsize_fail
	; Write zero byte at current file position
	invoke	oswrite,handle,addr zbuf,0
    chsize_back:
	invoke	lseek,handle,offs,SEEK_SET
	dec	eax
	jz	chsize_fail
	xor	eax,eax
endif
    chsize_end:
	ret
chsize	endp
endif
	end
